/*
Project: Serial MP3 Player module
Function: Plays the first song in the micro sd card
*/
//*************************************************************************
#include <SoftwareSerial.h>//include library code
//*************************************************************************
#define ARDUINO_RX 5//connect to TX pin of the Serial MP3 Player module
#define ARDUINO_TX 4//connect to RX pin of the Serial MP3 Player module
SoftwareSerial mySerial(ARDUINO_RX, ARDUINO_TX);//setup a myserial object
static int8_t Send_buf[8] = {0} ;
//define the commands
#define CMD_PLAY_W_INDEX 0X03
#define CMD_SET_VOLUME 0X06
#define CMD_SEL_DEV 0X09
#define DEV_TF 0X02
#define CMD_PLAY 0X0D
#define CMD_PAUSE 0X0E
#define CMD_SINGLE_CYCLE 0X19
#define SINGLE_CYCLE_ON 0X00
#define SINGLE_CYCLE_OFF 0X01
#define CMD_PLAY_W_VOL 0X22
//*************************************************************************
void setup()
{
  mySerial.begin(9600);//initialize serial communication at 9600 bps
  delay(500);//Wait chip initialization is complete
  sendCommand(CMD_SEL_DEV, DEV_TF);//select the TF card
  delay(200);//wait for 200ms
  sendCommand(CMD_PLAY_W_VOL, 0X0F01);//0X0F01 - PLAYS FIRST SONG  - you can change and play another, for example 0X0F02 SECOND SONG, 0X0F03 THIRD SONG....with volume 15 class
 
}
void loop()
{
}
//*************************************************************************
void sendCommand(int8_t command, int16_t dat)
{
  delay(20);
  Send_buf[0] = 0x7e; //starting byte
  Send_buf[1] = 0xff; //version
  Send_buf[2] = 0x06; //the number of bytes of the command without starting byte and ending byte
  Send_buf[3] = command; //
  Send_buf[4] = 0x00;//0x00 = no feedback, 0x01 = feedback
  Send_buf[5] = (int8_t)(dat >> 8);//datah
  Send_buf[6] = (int8_t)(dat); //datal
  Send_buf[7] = 0xef; //ending byte
  for (uint8_t i = 0; i < 8; i++) //
  {
    mySerial.write(Send_buf[i]) ;
  }
}
